#/usr/bin/perl
<<DOC; 
Votre Nom : Arij SEDIRI
 usage : perl parcours-arborescence-fichiers repertoire-a-parcourir
 Le programme prend en entre le nom du rpertoire contenant les fichiers
  traiter
 Le programme construit en sortie un fichier structur contenant sur chaque
 ligne le nom du fichier et le rsultat du filtrage :
<FICHIER><NOM>du fichier</NOM></FICHIER><CONTENU>du filtrage</CONTENU></FICHIER>
DOC
#-----------------------------------------------------------
my $rep="$ARGV[0]";
# on s'assure que le nom du rpertoire ne se termine pas par un "/"
$rep=~ s/[\/]$//;
# on initialise une variable contenant le flux de sortie 
my $DUMPFULL1="";
my $cptArticle=0;
my %dicoDesTitres=();
my %dicoDesDescriptions=();
#----------------------------------------

my $output2="SORTIE.xml";
if (!open (FILEOUTXML,">$output2")) { die "Pb a l'ouverture du fichier $output2"};
#----------------------------------------
&parcoursarborescencefichiers($rep);	#recurse!
#----------------------------------------
print FILEOUTXML "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
print FILEOUTXML "<PARCOURS>\n";
print FILEOUTXML "<NOM>Arij SEDIRI</NOM>\n";
print FILEOUTXML $DUMPFULL1;
print FILEOUTXML "</PARCOURS>\n";
close(FILEOUTXML);

exit;
#----------------------------------------------
sub parcoursarborescencefichiers {
    # stockage de contenu de rpertoire dans le tableau @files 
	my $path = shift(@_);
    opendir(DIR, $path) or die "can't open $path: $!\n";
    my @files = readdir(DIR);
    closedir(DIR);
	
	# boucle for pour parcourir le contenu de tableau
    foreach my $file (@files) 
	{
		next if $file =~ /^\.\.?$/;
		$file = $path."/".$file;
		if (-d $file) {
			&parcoursarborescencefichiers($file);	#recurse!
		}
		if ((-f $file) && ($file=~/\.xml$/) && ($file=~/3214/) ) 
		{
				print $i++,"\n";
				open(FILEIN,$file);
				#iinitialisation de la variable $texte
				my $texte=""; 
			
				#tant que le programme peut lire des lignes dans le fichier, il le fait:
				while (my $ligne=<FILEIN>) 
				{
					#je retire le retour  la ligne et on remplace par rien
					$ligne =~ s/\n//g; 
					#je concatne les lignes du fichier pour obtenir un texte
					$texte .= $ligne; 
				}
				#je cherche tout ce qu'il y a comme blanc entre les chevrons fermants et chevrons ouvrants et je remplace par a: ><
				$texte =~ s/> *</></g; 
				
				while ($texte =~ /<item><title>([^<]+)<\/title>.+?<description>([^<]+)<\/description>/gi) 
				{	
					my $titre=$1;
					$titre=&nettoieText($titre);
					my $resume=$2;
					$resume=&nettoieText($resume);
					
					if (!(exists($dicoDesTitres{$titre})) && !(exists($dicoDesDescriptions{$resume})))  
					{
					    $cptArticle++;
						my $titreetiquete=&etiquetageavectreetagger($titre);
						my $texteetiquete=&etiquetageavectreetagger($resume);
						
						$DUMPFULL1.="<article numero=\"$cptArticle\">\n";
						$DUMPFULL1.="<title>\n$titreetiquete\n</title>\n<abstract>\n$texteetiquete\n</abstract>\n";
						$DUMPFULL1.="</article>\n";
						$dicoDesTitres{$titre}++;
						$dicoDesDescriptions{$resume}++;
					}
				}
				close(FILEIN);
			}
		
    }
}
#----------------------------------------------
sub nettoieText {
   my $texte=shift; 
	$texte =~ s/&lt;/</g;
    $texte =~ s/&gt;/>/g;
    $texte =~ s/<a href[^>]+>//g;
    $texte =~ s/<img[^>]+>//g;
    $texte =~ s/<\/a>//g;
    $texte =~ s/&#38;#39;/'/g;
    $texte =~ s/&#38;#34;/"/g;
    $texte =~ s/<[^>]+>//g;
    $texte =~s/&#39;/\'/g;
    $texte =~s/&#34;/\"/g;
    $texte =~s/&#233;//g;
    $texte =~s/&#234;//g;
    $texte =~s/&amp;eacute;//g;
    $texte =~s/&amp;egrave;//g;
    $texte =~s/&amp;icirc;/\/g;
    $texte =~s/&amp;ocirc;/\/g;
    $texte =~s/&amp;ccedil;/\/g;
    $texte =~s/&amp;agrave;/\/g;
    $texte =~s/&#38;/&/g;
    $texte =~s/<.*$//g;
	$texte =~ s/&amp;|&#38;/&/g;
	$texte =~ s/&amp;|&#38;/&/g; 
	$texte =~ s/&apos;|&#39;/'/g; 
	$texte =~ s/&nbsp;|&#160;/? /g; 
	$texte =~ s/&shy;|&#173;//g; 
	$texte =~ s/&quot;|&#34;/"/g; 
	$texte =~ s/&laquo;|&#171;//g; 
	$texte =~ s/&raquo;|&#187;//g; 
	$texte =~ s/&lsaquo;|&#8249;//g; 
	$texte =~ s/&rsaquo;|&#8250;//g; 
	$texte =~ s/&ldquo;|&#8220;//g; 
	$texte =~ s/&rdquo;|&#8221;//g; 
	$texte =~ s/&bdquo;|&#8222;//g; 
	$texte =~ s/&lsquo;|&#8216;//g; 
	$texte =~ s/&bdquo;|&#8222;//g; 
	$texte =~ s/&rsquo;|&#8217;//g; 
	$texte =~ s/&sbquo;|&#8218;//g; 
	$texte =~ s/&hellip;|&#8230;//g; 
	$texte =~ s/!|&#33;/!/g; 
	$texte =~ s/&iexcl;|&#161;//g; 
	$texte =~ s/\?|&#63;/\?/g;
	$texte =~ s/\(|&#40;/\(/g; 
	$texte =~ s/\)|&#41;/\)/g; 
	$texte =~ s/\[|&#91;/\[/g; 
	$texte =~ s/]|&#93;/]/g; 
	$texte =~ s/{|&#123;/{/g; 
	$texte =~ s/}|&#125;/}/g; 
	$texte =~ s/&uml;|&#168;//g; 
	$texte =~ s/&acute;|&#180;//g; 
	$texte =~ s/`|&#96;/`/g; 
	$texte =~ s/\^|&#94;/\^/g; 
	$texte =~ s/&circ;|&#710;//g; 
	$texte =~ s/~|&#126;/~/g; 
	$texte =~ s/#|&#35;/#/g; 
	$texte =~ s/\*|&#42;/\*/g; 
	$texte =~ s/,|&#44;/,/g; 
	$texte =~ s/\.|&#46;/\./g; 
	$texte =~ s/:|&#58;/:/g; 
	$texte =~ s/;|&#59;/;/g; 
	$texte =~ s/&middot;|&#183;//g; 
	$texte =~ s/&bull;|&#8226;//g; 
	$texte =~ s/&macr;|&#175;//g; 
	$texte =~ s/-|&#45;/-/g; 
	$texte =~ s/&ndash;|&#8211;//g; 
	$texte =~ s/&mdash;|&#8212;//g; 
	$texte =~ s/_|&#95;/_/g; 
	$texte =~ s/\||&#124;/\|/g; 
	$texte =~ s/&brvbar;|&#166;//g; 
	$texte =~ s/&zwj;|&#8205;/?/g; 
	$texte =~ s/&dagger;|&#8224;//g; 
	$texte =~ s/&Dagger;|&#8225;//g; 
	$texte =~ s/&Dagger;|&#8225;//g; 
	$texte =~ s/&sect;|&#167;//g;
	$texte =~ s/&para;|&#182;//g;
	$texte =~ s/&copy;|&#169;//g;
	$texte =~ s/&reg;|&#174;//g;
	$texte =~ s/&trade;|&#8482;//g;
	$texte =~ s/@|&#64;/@/g;
	$texte =~ s/\/|&#47;/\//g;
	$texte =~ s/\\|&#92;/\\/g;
	$texte =~ s/&loz;|&#9674;/?/g;
	$texte =~ s/&spades;|&#9824;/?/g;
	$texte =~ s/&clubs;|&#9827;/?/g;
	$texte =~ s/&hearts;|&#9829;/?/g;
	$texte =~ s/&diams;|&#9830;/?/g;
	$texte =~ s/&larr;|&#8592;/?/g;
	$texte =~ s/&uarr;|&#8593;/?/g;
	$texte =~ s/&rarr;|&#8594;/?/g;
	$texte =~ s/&darr;|&#8595;/?/g;
	$texte =~ s/&harr;|&#8596;/?/g;
	$texte =~ s/&aacute;|&#225;//g;
	$texte =~ s/&Aacute;|&#193;//g;
	$texte =~ s/&acirc;|&#226;//g;
	$texte =~ s/&Acirc;|&#194;//g;
	$texte =~ s/&agrave;|&#224;//g;
	$texte =~ s/&Agrave;|&#192;//g;
	$texte =~ s/&aring;|&#229;//g;
	$texte =~ s/&Aring;|&#197;//g;
	$texte =~ s/&atilde;|&#227;//g;
	$texte =~ s/&Atilde;|&#195;//g;
	$texte =~ s/&auml;|&#228;//g;
	$texte =~ s/&Auml;|&#196;//g;
	$texte =~ s/&aelig;|&#230;//g;
	$texte =~ s/&AElig;|&#198;//g;
	$texte =~ s/&ccedil;|&#231;//g;
	$texte =~ s/&Ccedil;|&#199;//g;
	$texte =~ s/&eacute;|&#233;//g;
	$texte =~ s/&Eacute;|&#201;//g;
	$texte =~ s/&ecirc;|&#234;//g;
	$texte =~ s/&Ecirc;|&#202;//g;
	$texte =~ s/&egrave;|&#232;//g;
	$texte =~ s/&Egrave;|&#200;//g;
	$texte =~ s/&euml;|&#235;//g;
	$texte =~ s/&Euml;|&#203;//g;
	$texte =~ s/&iacute;|&#237;//g;
	$texte =~ s/&Iacute;|&#205;//g;
	$texte =~ s/&icirc;|&#238;//g;
	$texte =~ s/&Icirc;|&#206;//g;
	$texte =~ s/&igrave;|&#236;//g;
	$texte =~ s/&Igrave;|&#204;//g;
	$texte =~ s/&iuml;|&#239;//g;
	$texte =~ s/&Iuml;|&#207;//g;
	$texte =~ s/&ntilde;|&#241;//g;
	$texte =~ s/&Ntilde;|&#209;//g;
	$texte =~ s/&oacute;|&#243;//g;
	$texte =~ s/&Oacute;|&#211;//g;
	$texte =~ s/&ocirc;|&#244;//g;
	$texte =~ s/&Ocirc;|&#212;//g;
	$texte =~ s/&ograve;|&#242;//g;
	$texte =~ s/&Ograve;|&#210;//g;
	$texte =~ s/&oslash;|&#248;//g;
	$texte =~ s/&Oslash;|&#216;//g;
	$texte =~ s/&otilde;|&#245;//g;
	$texte =~ s/&Otilde;|&#213;//g;
	$texte =~ s/&ouml;|&#246;//g;
	$texte =~ s/&Ouml;|&#214;//g;
	$texte =~ s/&oelig;|&#156;//g;
	$texte =~ s/&OElig;|&#140;//g;
	$texte =~ s/&scaron;|&#353;//g;
	$texte =~ s/&Scaron;|&#352;//g;
	$texte =~ s/&szlig;|&#223;//g;
	$texte =~ s/&eth;|&#240;//g;
	$texte =~ s/&ETH;|&#208;//g;
	$texte =~ s/&thorn;|&#254;//g;
	$texte =~ s/&THORN;|&#222;//g;
	$texte =~ s/&uacute;|&#250;//g;
	$texte =~ s/&Uacute;|&#218;//g;
	$texte =~ s/&ucirc;|&#251;//g;
	$texte =~ s/&Ucirc;|&#219;//g;
	$texte =~ s/&ugrave;|&#249;//g;
	$texte =~ s/&Ugrave;|&#217;//g;
	$texte =~ s/&uuml;|&#252;//g;
	$texte =~ s/&Uuml;|&#220;//g;
	$texte =~ s/&yacute;|&#253;//g;
	$texte =~ s/&Yacute;|&#221;//g;
	$texte =~ s/&yuml;|&#255;//g;
	$texte =~ s/&Yuml;|&#376;//g;
	$texte =~ s/&curren;|&#164;//g;
	$texte =~ s/&euro;|&#128;//g;
	$texte =~ s/\$|&#36;/\$/g;
	$texte =~ s/&cent;|&#162;//g;
	$texte =~ s/&pound;|&#163;//g;
	$texte =~ s/&yen;|&#165;//g;
	$texte =~ s/&fnof;|&#402;//g;
	$texte =~ s/&alpha;|&#945;/a/g;
	$texte =~ s/&Alpha;|&#913;/?/g;
	$texte =~ s/&beta;|&#946;//g;
	$texte =~ s/&Beta;|&#914;/?/g;
	$texte =~ s/&gamma;|&#947;/?/g;
	$texte =~ s/&Gamma;|&#915;/G/g;
	$texte =~ s/&delta;|&#948;/d/g;
	$texte =~ s/&Delta;|&#916;/?/g;
	$texte =~ s/&epsilon;|&#949;/e/g;
	$texte =~ s/&Epsilon;|&#917;/?/g;
	$texte =~ s/&zeta;|&#950;/?/g;
	$texte =~ s/&Zeta;|&#918;/?/g;
	$texte =~ s/&eta;|&#951;/?/g;
	$texte =~ s/&Eta;|&#919;/?/g;
	$texte =~ s/&theta;|&#952;/?/g;
	$texte =~ s/&Theta;|&#920;/T/g;
	$texte =~ s/&iota;|&#953;/?/g;
	$texte =~ s/&Iota;|&#921;/?/g;
	$texte =~ s/&kappa;|&#954;/?/g;
	$texte =~ s/&Kappa;|&#922;/?/g;
	$texte =~ s/&lambda;|&#955;/?/g;
	$texte =~ s/&Lambda;|&#923;/?/g;
	$texte =~ s/&mu;|&#956;//g;
	$texte =~ s/&Mu;|&#924;/?/g;
	$texte =~ s/&nu;|&#957;/?/g;
	$texte =~ s/&Nu;|&#925;/?/g;
	$texte =~ s/&xi;|&#958;/?/g;
	$texte =~ s/&Xi;|&#926;/?/g;
	$texte =~ s/&omicron;|&#959;/?/g;
	$texte =~ s/&Omicron;|&#927;/?/g;
	$texte =~ s/&pi;|&#960;/p/g;
	$texte =~ s/&Pi;|&#928;/?/g;
	$texte =~ s/&rho;|&#961;/?/g;
	$texte =~ s/&Rho;|&#929;/?/g;
	$texte =~ s/&sigma;|&#963;/s/g;
	$texte =~ s/&sigmaf;|&#962;/?/g;
	$texte =~ s/&Sigma;|&#931;/S/g;
	$texte =~ s/&tau;|&#964;/t/g;
	$texte =~ s/&Tau;|&#932;/?/g;
	$texte =~ s/&upsilon;|&#965;/?/g;
	$texte =~ s/&Upsilon;|&#933;/?/g;
	$texte =~ s/&phi;|&#966;/f/g;
	$texte =~ s/&Phi;|&#934;/F/g;
	$texte =~ s/&chi;|&#967;/?/g;
	$texte =~ s/&Chi;|&#935;/?/g;
	$texte =~ s/&psi;|&#968;/?/g;
	$texte =~ s/&Psi;|&#936;/?/g;
	$texte =~ s/&omega;|&#969;/?/g;
	$texte =~ s/&Omega;|&#937;/O/g;
	$texte  =~ s/&deg;|&#176;//g;
	$texte =~ s/&micro;|&#181;//g;
	$texte =~ s/&lt;|&#60;/</g;
	$texte =~ s/&gt;|&#62;/>/g;
	$texte =~ s/&le;|&#8804;/=/g;
	$texte =~ s/&ge;|&#8805;/=/g;
	$texte =~ s/=|&#61;/=/g;
	$texte =~ s/&asymp;|&#8776;//g;
	$texte =~ s/&ne;|&#8800;/?/g;
	$texte =~ s/&equiv;|&#8801;/=/g;
	$texte =~ s/&plusmn;|&#177;//g;
	$texte =~ s/&minus;|&#8722;/-/g;
	$texte =~ s/\+|&#43;/\+/g;
	$texte =~ s/&times;|&#215;//g;
	$texte =~ s/&divide;|&#247;//g;
	$texte =~ s/&frasl;|&#8260;//g;
	$texte =~ s/%|&#37;/%/g;
	$texte =~ s/&permil;|&#8240;//g;
	$texte =~ s/&frac14;|&#188;//g;
	$texte =~ s/&frac12;|&#188;//g;
	$texte =~ s/&frac34;|&#188;//g;
	$texte =~ s/&sup1;|&#185;//g;
	$texte =~ s/&sup2;|&#178;//g;
	$texte =~ s/&sup3;|&#179;//g;
	$texte =~ s/&ordm;|&#186;//g;
	$texte =~ s/&ordf;|&#170;//g;
	$texte =~ s/&fnof;|&#402;//g;
	$texte =~ s/&prime;|&#8242;/'/g;
	$texte =~ s/&Prime;|&#8243;/?/g;
	$texte =~ s/&part;|&#8706;/?/g;
	$texte =~ s/&prod;|&#8719;/?/g;
	$texte =~ s/&sum;|&#8721;/?/g;
	$texte =~ s/&radic;|&#8730;/v/g;
	$texte =~ s/&infin;|&#8734;/8/g;
	$texte =~ s/&not;|&#172;//g;
	$texte =~ s/&cap;|&#8745;/n/g;
	$texte =~ s/&int;|&#8747;/?/g;
	#$texte =~ s/et|&/?/g;
	$texte =~ s/&/et/g;
	$texte =~ s/<.+?>//g;
	return $texte;
}
#------------------------------------------------
sub etiquetageavectreetagger 
{
    my ($texte)=@_;
	my $codage="utf-8";
    my $tmptag="texteaetiqueter.txt";
    
	#----- le titre
	open (TMPFILE,">:encoding(utf-8)", $tmptag);
    print TMPFILE $texte,"\n";
    close(TMPFILE);
    system("perl ./treetagger-win32/cmd/tokenise-fr.pl $tmptag | ./tree-tagger.exe ./treetagger-win32/lib/french-utf8.par -lemma -token -no-unknown -sgml > treetagger.txt");    
    system("perl ./treetagger-win32/cmd/treetagger2xml-utf8.pl treetagger.txt $codage ");
    # lecture du resultat tagge en xml :
    open(OUT,"<:encoding(utf-8)","treetagger.txt.xml");
    my $fistline=<OUT>;
    my $texteetiquete="";
    while (my $l=<OUT>) 
	{
		$texteetiquete.=$l;
    }
    close(OUT);
	
	
    # on renvoie les resultats :
    return ($texteetiquete);
}
